'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _Expression2 = require('../Expression');

var _Expression3 = _interopRequireDefault(_Expression2);

var assignmentOperators = {
    '=': true,
    '+=': true,
    '-=': true,
    '*=': true,
    '/=': true,
    '%=': true,
    '<<=': true,
    '>>=': true,
    '>>>=': true,
    '|=': true,
    '^=': true,
    '&=': true
};

var AssignmentExpression = (function (_Expression) {
    _inherits(AssignmentExpression, _Expression);

    function AssignmentExpression(childNodes) {
        _classCallCheck(this, AssignmentExpression);

        _get(Object.getPrototypeOf(AssignmentExpression.prototype), 'constructor', this).call(this, 'AssignmentExpression', childNodes);
    }

    _createClass(AssignmentExpression, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            var left = children.passAssignable();
            children.skipNonCode();
            children.assertToken('Punctuator', assignmentOperators);
            var operator = children.currentElement.value;
            children.moveNext();
            children.skipNonCode();
            var right = children.passExpression();
            children.assertEnd();

            this._left = left;
            this._operator = operator;
            this._right = right;
        }
    }, {
        key: 'left',
        get: function get() {
            return this._left;
        }
    }, {
        key: 'right',
        get: function get() {
            return this._right;
        }
    }, {
        key: 'operator',
        get: function get() {
            return this._operator;
        }
    }]);

    return AssignmentExpression;
})(_Expression3['default']);

exports['default'] = AssignmentExpression;
module.exports = exports['default'];